HTMLHostManagerServlet (Apache Tomcat 9.0.104 API Documentation)
Description: declaration: package: org.apache.catalina.manager.host, class: HTMLHostManagerServlet

# Class HTMLHostManagerServlet

java.lang.Object
javax.servlet.GenericServlet
javax.servlet.http.HttpServlet
org.apache.catalina.manager.host.HostManagerServlet
org.apache.catalina.manager.host.HTMLHostManagerServlet

All Implemented Interfaces:
  `Serializable`, `Servlet`, `ServletConfig`, `ContainerServlet`

public class HTMLHostManagerServlet extends HostManagerServlet
Servlet that enables remote management of the virtual hosts deployed on the server. Normally, this functionality will be protected by a security constraint in the web application deployment descriptor. However, this requirement can be relaxed during testing.

The difference between the `HostManagerServlet` and this Servlet is that this Servlet prints out an HTML interface which makes it easier to administrate.

However if you use a software that parses the output of `HostManagerServlet` you won't be able to upgrade to this Servlet since the output are not in the same format as from `HostManagerServlet`

Author:
  Bip Thelin, Malcolm Edgar, Glenn L. Nielsen, Peter Rossbach
See Also:
  - `ManagerServlet`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class org.apache.catalina.manager.host.HostManagerServlet

  `context, debug, engine, installedHost, sm, wrapper`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HTMLHostManagerServlet()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected String`
  `add(HttpServletRequest request, String name, StringManager smClient)`
  Add a host using the specified parameters.
  `void`
  `doGet(HttpServletRequest request, HttpServletResponse response)`
  Called by the server (via the `service` method) to allow a servlet to handle a GET request.
  `void`
  `doPost(HttpServletRequest request, HttpServletResponse response)`
  Called by the server (via the `service` method) to allow a servlet to handle a POST request.
  `void`
  `list(HttpServletRequest request, HttpServletResponse response, String message, StringManager smClient)`
  Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.
  `protected String`
  `persist(StringManager smClient)`
  Persist the current configuration to server.xml.
  `protected String`
  `remove(String name, StringManager smClient)`
  Remove the specified host.
  `protected String`
  `start(String name, StringManager smClient)`
  Start the host with the specified name.
  `protected String`
  `stop(String name, StringManager smClient)`
  Stop the host with the specified name.

  ### Methods inherited from class org.apache.catalina.manager.host.HostManagerServlet

  `add, add, booleanParameter, destroy, getConfigBase, getWrapper, init, list, persist, remove, setWrapper, start, stop`

  ### Methods inherited from class javax.servlet.http.HttpServlet

  `doDelete, doHead, doOptions, doPut, doTrace, getLastModified, service, service`

  ### Methods inherited from class javax.servlet.GenericServlet

  `getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, log, log`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### HTMLHostManagerServlet

    public HTMLHostManagerServlet()

- ## Method Details

  - ### doGet

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException
    Description copied from class: `javax.servlet.http.HttpServlet`
    Called by the server (via the `service` method) to allow a servlet to handle a GET request.

    Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

    When overriding this method, read the request data, write the response headers, get the response's Writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

    The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

    Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

    When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

    The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

    The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

    If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

    Overrides:
      `doGet` in class `HostManagerServlet`
    Parameters:
      `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
      `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
    Throws:
      `IOException` - if an input or output error is detected when the servlet handles the GET request
      `ServletException` - if the request for the GET could not be handled
    See Also:
      - `ServletResponse.setContentType(java.lang.String)`

  - ### doPost

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    Description copied from class: `javax.servlet.http.HttpServlet`
    Called by the server (via the `service` method) to allow a servlet to handle a POST request. The HTTP POST method allows the client to send data of unlimited length to the Web server a single time and is useful when posting information such as credit card numbers.

    When overriding this method, read the request data, write the response headers, get the response's Writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

    The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

    Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

    When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

    This method does not need to be either safe or idempotent. Operations requested through POST can have side effects for which the user can be held accountable, for example, updating stored data or buying items online.

    If the HTTP POST request is incorrectly formatted, `doPost` returns an HTTP "Bad Request" message.

    Overrides:
      `doPost` in class `HttpServlet`
    Parameters:
      `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
      `response` - an `HttpServletResponse` object that contains the response the servlet sends to the client
    Throws:
      `ServletException` - if the request for the POST could not be handled
      `IOException` - if an input or output error is detected when the servlet handles the request
    See Also:
      - `ServletOutputStream`
      - `ServletResponse.setContentType(java.lang.String)`

  - ### add

    protected String add(HttpServletRequest request, String name, StringManager smClient)
    Add a host using the specified parameters.
    Parameters:
      `request` - The Servlet request
      `name` - Host name
      `smClient` - StringManager for the client's locale
    Returns:
      output

  - ### remove

    protected String remove(String name, StringManager smClient)
    Remove the specified host.
    Parameters:
      `name` - Host name
      `smClient` - StringManager for the client's locale
    Returns:
      output

  - ### start

    protected String start(String name, StringManager smClient)
    Start the host with the specified name.
    Parameters:
      `name` - Host name
      `smClient` - StringManager for the client's locale
    Returns:
      output

  - ### stop

    protected String stop(String name, StringManager smClient)
    Stop the host with the specified name.
    Parameters:
      `name` - Host name
      `smClient` - StringManager for the client's locale
    Returns:
      output

  - ### persist

    protected String persist(StringManager smClient)
    Persist the current configuration to server.xml.
    Parameters:
      `smClient` - i18n resources localized for the client
    Returns:
      output

  - ### list

    public void list(HttpServletRequest request, HttpServletResponse response, String message, StringManager smClient) throws IOException
    Render an HTML list of the currently active Contexts in our virtual host, and memory and server status information.
    Parameters:
      `request` - The request
      `response` - The response
      `message` - a message to display
      `smClient` - StringManager for the client's locale
    Throws:
      `IOException` - An IO error occurred